#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Shared ;
namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private PointF nextTablePosition;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//Create a new PDF Document. The pdfDoc object represents the PDF document.
			//This document has one page by default and additional pages have to be added.
			PDFDocument pdfDoc = new PDFDocument();

			//Adding a font that can be used to draw Text inside the PDF document.
			//Using the Predefined fonts to draw the text. 
			IPDFFont pdfFont = pdfDoc.Fonts.Add( FontBaseFamily.Courier );

			//Accessing the first page in the pages collection.
			IPDFPage firstPage = pdfDoc.Pages[0];
			
			//Create a new PDF Table.
			ITable table = pdfDoc.CreateTable();

			//To make the Table span over multiple pages without getting cut.
			//Setting Table properties.
			table.PublishHeader = true;
			table.PageBreakBehavior = AutoBreakBehavior.FullBreak;
			table.RepeatHeader = true;

			//Setting properties.
			table.Style.BorderColors.All =Color.Red;
			
			//Import DataTable.
			table.ImportDataTable(GetTable(1500,7),true);
			
			//Format the 1st table
			for (int i = 0, len = table.Columns.Count; i < len; ++i)
			{
				table.Header[0].Cells[i].Style.BackColor = Color.YellowGreen;
				table.Header[0].Cells[i].Style.BorderColors.All = Color.Green;
				table.Header[0].Cells[i].Style.BordersWidth.All = 1;

			}
			for (int i = 0; i < table.Rows.Count; ++i)
			{
				for (int j = 0; j < table.Columns.Count; ++j)
				{
					table.Rows[i].AutoHeight=true;
					table.Rows[i].Cells[j].Style.BackColor = Color.WhiteSmoke;
					table.Rows[i].Cells[j].Style.BorderColors.All = Color.Green;
					table.Rows[i].Cells[j].Style.BordersWidth.All =1;
               
				}
			}
                             
			for (int i = 0, len = table.Columns.Count; i < len; ++i)
			{
				table.Columns[i].Width =50 ;
			}
		
			//Setting the location to publish the table.
			PointF tableLocation = new PointF(50, 0);

			//Event that gets fired after a table is published.
			table.AfterTablePublishing +=new AfterTablePublishingEventHandler(table_AfterTablePublishing);

			//Getting the size of the table and publishing in the pdf document.
			SizeF tableSize = table.Publish(tableLocation,pdfDoc.LastPage); 
			
			//Insert Second Table
			//Create a new PDF Table
			ITable tableTwo = pdfDoc.CreateTable();

			//To make the second Table span over multiple pages without getting cut.
			tableTwo.PageBreakBehavior = AutoBreakBehavior.FullBreak;
			tableTwo.RepeatHeader = true;

			//Setting properties.
			tableTwo.Style.BorderColors.All =Color.Red;

			//Import DataTable.
			tableTwo.ImportDataTable(GetTable(55,7),true);	

			//Format the 2nd table
			for (int i = 0, len = tableTwo.Columns.Count; i < len; ++i)
			{
				tableTwo.Header[0].Cells[i].Style.BackColor = Color.LightBlue;
				tableTwo.Header[0].Cells[i].Style.BorderColors.All = Color.DarkSlateBlue;
				tableTwo.Header[0].Cells[i].Style.BordersWidth.All = 1;

			}
			for (int i = 0; i < tableTwo.Rows.Count; ++i)
			{
				for (int j = 0; j < tableTwo.Columns.Count; ++j)
				{
					tableTwo.Rows[i].AutoHeight=true;
					tableTwo.Rows[i].Cells[j].Style.BackColor = Color.GhostWhite;
					tableTwo.Rows[i].Cells[j].Style.BorderColors.All = Color.LightBlue;
					tableTwo.Rows[i].Cells[j].Style.BordersWidth.All =1;
               
				}
			}
                             
			for (int i = 0, len = tableTwo.Columns.Count; i < len; ++i)
			{
				tableTwo.Columns[i].Width =50 ;
			}

			PointF tableTwoStartPosition = new PointF(this.nextTablePosition.X,this.nextTablePosition.Y);

			//Event that gets fired after a table is published.
			tableTwo.AfterTablePublishing +=new AfterTablePublishingEventHandler(table_AfterTablePublishing);

			//Publish the second table in the pdf document.
			tableTwo.Publish(tableTwoStartPosition,pdfDoc.LastPage);

			//Insert third Table
			//Create a new PDF Table
			ITable tableThree = pdfDoc.CreateTable();

			//To make the second Table span over multiple pages without getting cut.
			tableThree.PageBreakBehavior = AutoBreakBehavior.FullBreak;
			tableThree.RepeatHeader = true;

			//Setting properties.
			tableThree.Style.BorderColors.All =Color.Red;

			//Import DataTable.
			tableThree.ImportDataTable(GetTable(55,7),true);	

			PointF tableThreeStartPosition = new PointF(this.nextTablePosition.X,this.nextTablePosition.Y);
			
			//Publish the second table in the pdf document.
			tableThree.Publish(tableThreeStartPosition,pdfDoc.LastPage);


			//Save the PDF Document to disk.
			pdfDoc.Save("Sample.pdf");
			
			//Message box confirmation to view the created PDF document.
			if (MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf");
			}
			else
			{
				// Exit
				this.Close();
			}
		}

		private DataTable GetTable(int row, int col)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = col;
			int nRows = row;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn("Header"+ i.ToString()));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = i.ToString()+ "," +j.ToString();
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private void table_AfterTablePublishing(object sender, AfterTablePublishingEventArgs args)
		{
			nextTablePosition = args.LeftBottomLocation;
		}
	}
}

